---------------------
PatchSet 2537 
Date: 2001/06/14 20:36:15
Author: serassio
Branch: nt-2_3
Tag: (none) 
Log:
Backport of revised Windows NT code from 2.5 DEVEL branch

Members: 
	include/autoconf.h:1.1.2.2->1.1.2.3 
	include/autoconf.h.in:1.1.1.3.4.2.2.1->1.1.1.3.4.2.2.2 
	include/config.h:1.1.2.2->1.1.2.3 
	include/config.h.in:1.1.1.3.4.1.2.2->1.1.1.3.4.1.2.3 
	include/getopt.h:1.1->1.1.2.1 
	lib/win32lib.c:1.1->1.1.2.1 
	src/access_log.c:1.1.1.3.4.1.2.1->1.1.1.3.4.1.2.2 
	src/asn.c:1.1.1.3.4.2.2.1->1.1.1.3.4.2.2.2 
	src/cache_cf.c:1.1.1.3.4.4.2.2->1.1.1.3.4.4.2.3 
	src/defines.h:1.1.1.3.4.2.2.1->1.1.1.3.4.2.2.2 
	src/disk.c:1.1.1.3.4.1.2.2->1.1.1.3.4.1.2.3 
	src/dns_internal.c:1.1.1.1.4.6.2.1->1.1.1.1.4.6.2.2 
	src/globals.h:1.1.1.3.4.2.2.2->1.1.1.3.4.2.2.3 
	src/main.c:1.1.1.3.4.2.2.3->1.1.1.3.4.2.2.4 
	src/protos.h:1.1.1.3.4.1.2.3->1.1.1.3.4.1.2.4 
	src/readdir.c:1.1.2.1->1.1.2.2(DEAD) 
	src/squid.h:1.1.1.3.4.1.2.2->1.1.1.3.4.1.2.3 
	src/store.c:1.1.1.3.4.5.2.2->1.1.1.3.4.5.2.3 
	src/store_dir.c:1.1.1.3.4.2.2.2->1.1.1.3.4.2.2.3 
	src/store_dir_ufs.c:1.1.1.1.4.1.2.2->1.1.1.1.4.1.2.3 
	src/string-arrays.c:1.1.2.1->1.1.2.2(DEAD) 
	src/structs.h:1.1.1.3.4.2.2.2->1.1.1.3.4.2.2.3 
	src/tools.c:1.1.1.3.4.1.2.3->1.1.1.3.4.1.2.4 
	src/typedefs.h:1.1.1.3.4.1.2.2->1.1.1.3.4.1.2.3 
	src/url.c:1.1.1.3.4.4.2.1->1.1.1.3.4.4.2.2 
	src/useragent.c:1.1.1.3.4.1.2.2->1.1.1.3.4.1.2.3 
	src/win32.c:1.1.2.2->1.1.2.3 

Index: squid/include/autoconf.h
===================================================================
RCS file: /cvsroot/squid-sf//squid/include/Attic/autoconf.h,v
retrieving revision 1.1.2.2
retrieving revision 1.1.2.3
diff -u -r1.1.2.2 -r1.1.2.3
--- squid/include/autoconf.h	25 Mar 2001 17:49:42 -0000	1.1.2.2
+++ squid/include/autoconf.h	14 Jun 2001 20:36:15 -0000	1.1.2.3
@@ -100,7 +100,6 @@
  * directory.
  */
 #undef USE_USERAGENT_LOG
-//#define USE_USERAGENT_LOG 1
 
 /*
  * A dangerous feature which causes Squid to kill its parent process
@@ -116,7 +115,6 @@
  * Define to enable WCCP
  */
 #undef USE_WCCP
-#define USE_WCCP 1
 
 /*
  * Squid frequently calls gettimeofday() for accurate timestamping.
@@ -145,13 +143,16 @@
  * code is still semi-experimental. 
  */
 #undef USE_CACHE_DIGESTS
-//#define USE_CACHE_DIGESTS 1
 
 /*
  * Cache Array Routing Protocol
  */
 #undef USE_CARP
-#define USE_CARP 1
+
+/*
+ * Define Windows NT & Windows 2000 run service mode
+ */
+#define USE_WIN32_SERVICE 1
 
 /* Define if struct tm has tm_gmtoff member */
 #undef HAVE_TM_GMTOFF
@@ -165,7 +166,7 @@
 
 /* Maximum number of open filedescriptors */
 #undef SQUID_MAXFD
-//#define SQUID_MAXFD 2048
+#define SQUID_MAXFD 2048
 
 /* UDP send buffer size */
 #undef SQUID_UDP_SO_SNDBUF
@@ -204,6 +205,7 @@
 
 /* Define if we should use GNU regex */
 #undef USE_GNUREGEX
+#define USE_GNUREGEX 1
 
 /* signed size_t, grr */
 #undef ssize_t
@@ -219,6 +221,9 @@
 /* Define if you have struct rusage */
 #undef HAVE_STRUCT_RUSAGE
 
+/* Define if you have PSAPI.DLL on Windows systems */
+#define HAVE_WIN32_PSAPI 1
+
 /*
  * This makes warnings go away.  If you have socklen_t defined in your
  * /usr/include files, then this should remain undef'd.  Otherwise it
@@ -276,7 +281,6 @@
  * the dnsserver processes instead.
  */
 #undef USE_DNSSERVERS
-#define USE_DNSSERVERS 1
 /*
  * we check for the existance of struct mallinfo
  */
@@ -334,6 +338,7 @@
 
 /* Define if you have the getrusage function.  */
 #undef HAVE_GETRUSAGE
+#define HAVE_GETRUSAGE 1
 
 /* Define if you have the getspnam function.  */
 #undef HAVE_GETSPNAM
@@ -491,6 +496,7 @@
 
 /* Define if you have the <getopt.h> header file.  */
 #undef HAVE_GETOPT_H
+#define HAVE_GETOPT_H 1
 
 /* Define if you have the <gnumalloc.h> header file.  */
 #undef HAVE_GNUMALLOC_H
Index: squid/include/autoconf.h.in
===================================================================
RCS file: /cvsroot/squid-sf//squid/include/Attic/autoconf.h.in,v
retrieving revision 1.1.1.3.4.2.2.1
retrieving revision 1.1.1.3.4.2.2.2
diff -u -r1.1.1.3.4.2.2.1 -r1.1.1.3.4.2.2.2
--- squid/include/autoconf.h.in	6 Jan 2001 12:51:32 -0000	1.1.1.3.4.2.2.1
+++ squid/include/autoconf.h.in	14 Jun 2001 20:36:15 -0000	1.1.1.3.4.2.2.2
@@ -144,6 +144,11 @@
  */
 #undef USE_CARP
 
+/*
+ * Define Windows NT & Windows 2000 run service mode
+ */
+#define USE_WIN32_SERVICE 1
+
 /* Define if struct tm has tm_gmtoff member */
 #undef HAVE_TM_GMTOFF
 
@@ -202,6 +207,9 @@
 /* Define if you have struct rusage */
 #undef HAVE_STRUCT_RUSAGE
 
+/* Define if you have PSAPI.DLL on Windows systems */
+#define HAVE_WIN32_PSAPI 1
+
 /*
  * This makes warnings go away.  If you have socklen_t defined in your
  * /usr/include files, then this should remain undef'd.  Otherwise it
Index: squid/include/config.h
===================================================================
RCS file: /cvsroot/squid-sf//squid/include/config.h,v
retrieving revision 1.1.2.2
retrieving revision 1.1.2.3
diff -u -r1.1.2.2 -r1.1.2.3
--- squid/include/config.h	25 Mar 2001 17:49:42 -0000	1.1.2.2
+++ squid/include/config.h	14 Jun 2001 20:36:15 -0000	1.1.2.3
@@ -103,16 +103,24 @@
 #elif defined(WIN32) || defined(WINNT) || defined(__WIN32__) || defined(__WIN32)
 #define _SQUID_MSWIN_
 
-#define SQUID_MAXFD 128
+/* Some tricks for MS Compilers */
+#define alloca _alloca
+#define chdir _chdir
+#define getcwd _getcwd
+#define getpid _getpid
+#define mkdir _mkdir
+#define setmode _setmode
+#define snprintf _snprintf
+#define vsnprintf _vsnprintf
+#define O_BYNARY _O_BINARY
+#define O_TEXT _O_TEXT
+#define S_IRWXO 007
+#define	S_ISDIR(m) (((m) & _S_IFDIR) == _S_IFDIR)
+
 #include <stddef.h>
-#define FD_SETSIZE 128
 #include <ws2spi.h>
-#include <sys/timeb.h>
-#include <malloc.h>
-#include "GNUregex.h"
 #include "readdir.h"
 
-extern int Win32SockInit(void);
 #define SQUIDHOSTNAMELEN 128
 typedef char *caddr_t;
 #undef FD_CLOSE
@@ -127,16 +135,8 @@
 #define ETIMEDOUT WSAETIMEDOUT
 #define uid_t int
 #define gid_t int
-#define xstrdup _strdup
-#define snprintf _snprintf
-#define chdir _chdir
-#define getcwd _getcwd
 #define strcasecmp _stricmp
 #define strncasecmp _strnicmp
-#define vsnprintf _vsnprintf
-#define getpid _getpid
-#define mkdir _mkdir
-#define	S_ISDIR(m)	(((m) & _S_IFDIR) == _S_IFDIR)
 
 #if defined (COMM_C) || defined (COMM_SELECT_C)
 #define recv(x,y,z) recv(x,y,z,0)
@@ -175,16 +175,6 @@
 #define commSetSelect(x,y,z,u,v) commSetSelectS(x,y,z,u,v)
 #endif
 
-
-#define	SIGHUP	1	/* hangup */
-#define	SIGKILL	9	/* kill (cannot be caught or ignored) */
-#define	SIGBUS	10	/* bus error */
-#define	SIGPIPE	13	/* write on a pipe with no one to read it */
-#define	SIGCHLD	20	/* to parent on child stop or exit */
-#define SIGUSR1 30	/* user defined signal 1 */
-#define SIGUSR2 31	/* user defined signal 2 */
-extern void gettimeofday( struct timeval * ,void *);
-
 #elif defined(__APPLE__)
 #define _SQUID_APPLE_
 
Index: squid/include/config.h.in
===================================================================
RCS file: /cvsroot/squid-sf//squid/include/Attic/config.h.in,v
retrieving revision 1.1.1.3.4.1.2.2
retrieving revision 1.1.1.3.4.1.2.3
diff -u -r1.1.1.3.4.1.2.2 -r1.1.1.3.4.1.2.3
--- squid/include/config.h.in	25 Mar 2001 17:49:42 -0000	1.1.1.3.4.1.2.2
+++ squid/include/config.h.in	14 Jun 2001 20:36:15 -0000	1.1.1.3.4.1.2.3
@@ -1,5 +1,5 @@
 /*
- * $Id: config.h.in,v 1.1.1.3.4.1.2.2 2001/03/25 17:49:42 serassio Exp $
+ * $Id: config.h.in,v 1.1.1.3.4.1.2.3 2001/06/14 20:36:15 serassio Exp $
  *
  * AUTHOR: Duane Wessels
  *
@@ -103,6 +103,20 @@
 #elif defined(WIN32) || defined(WINNT) || defined(__WIN32__) || defined(__WIN32)
 #define _SQUID_MSWIN_
 
+/* Some tricks for MS Compilers */
+#define alloca _alloca
+#define chdir _chdir
+#define getcwd _getcwd
+#define getpid _getpid
+#define mkdir _mkdir
+#define setmode _setmode
+#define snprintf _snprintf
+#define vsnprintf _vsnprintf
+#define O_BYNARY _O_BINARY
+#define O_TEXT _O_TEXT
+#define S_IRWXO 007
+#define	S_ISDIR(m) (((m) & _S_IFDIR) == _S_IFDIR)
+
 #elif defined(__APPLE__)
 #define _SQUID_APPLE_
 
--- /dev/null	Wed Feb 14 00:52:54 2007
+++ squid/include/getopt.h	Wed Feb 14 00:53:42 2007
@@ -0,0 +1,73 @@
+/* ====================================================================
+ * The Apache Software License, Version 1.1
+ *
+ * Copyright (c) 2000 The Apache Software Foundation.  All rights
+ * reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ *
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in
+ *    the documentation and/or other materials provided with the
+ *    distribution.
+ *
+ * 3. The end-user documentation included with the redistribution,
+ *    if any, must include the following acknowledgment:
+ *       "This product includes software developed by the
+ *        Apache Software Foundation (http://www.apache.org/)."
+ *    Alternately, this acknowledgment may appear in the software itself,
+ *    if and wherever such third-party acknowledgments normally appear.
+ *
+ * 4. The names "Apache" and "Apache Software Foundation" must
+ *    not be used to endorse or promote products derived from this
+ *    software without prior written permission. For written
+ *    permission, please contact apache@apache.org.
+ *
+ * 5. Products derived from this software may not be called "Apache",
+ *    nor may "Apache" appear in their name, without prior written
+ *    permission of the Apache Software Foundation.
+ *
+ * THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED
+ * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
+ * DISCLAIMED.  IN NO EVENT SHALL THE APACHE SOFTWARE FOUNDATION OR
+ * ITS CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
+ * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
+ * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
+ * USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
+ * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
+ * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
+ * OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+ * SUCH DAMAGE.
+ * ====================================================================
+ *
+ * This software consists of voluntary contributions made by many
+ * individuals on behalf of the Apache Software Foundation.  For more
+ * information on the Apache Software Foundation, please see
+ * <http://www.apache.org/>.
+ *
+ * Portions of this software are based upon public domain software
+ * originally written at the National Center for Supercomputing Applications,
+ * University of Illinois, Urbana-Champaign.
+ */
+
+#ifndef GETOPT_H
+#define GETOPT_H
+
+#ifdef WIN32
+
+extern char *optarg;
+extern int optreset;
+extern int optind;
+extern int opterr;
+extern int optopt;
+int getopt(int argc, char* const *argv, const char *optstr);
+
+#endif /* WIN32 */
+
+#endif /* GETOPT_H */
--- /dev/null	Wed Feb 14 00:52:54 2007
+++ squid/lib/win32lib.c	Wed Feb 14 00:53:42 2007
@@ -0,0 +1,351 @@
+/*
+ * $Id: win32lib.c,v 1.1.2.1 2001/06/14 20:36:15 serassio Exp $
+ *
+ * * * * * * * * Legal stuff * * * * * * *
+ *
+ * (C) 2001 Guido Serassio <serassio@libero.it>,
+ *   inspired by previous work by Romeo Anghelache & Eric Stern.
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *  
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ * 
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111, USA.
+ *
+ */
+
+#include "squid.h"
+
+/* The following code section is part of an EXPERIMENTAL native */
+/* Windows NT/2000 Squid port - Compiles only on MS Visual C++  */
+#if defined(_SQUID_MSWIN_)
+#include <stdio.h>
+#include <windows.h>
+#include <process.h>
+#undef free
+#undef malloc
+#include <string.h>
+#include <stdlib.h>
+#include <malloc.h>
+#include <sys/timeb.h>
+#include <assert.h>
+
+#define OPTERRCOLON (1)
+#define OPTERRNF (2)
+#define OPTERRARG (3)
+
+char *optarg;
+int optreset = 0;
+int optind = 1;
+int opterr = 1;
+int optopt;
+
+int chroot (const char *dirname)
+{
+	if (SetCurrentDirectory(dirname))
+		return 0;
+	else
+		return GetLastError();
+}
+
+int kill(pid_t pid, int sig)
+{
+   	HANDLE hProcess;
+
+	if (sig == 0) {
+		if ((hProcess = OpenProcess(PROCESS_QUERY_INFORMATION |
+		    PROCESS_VM_READ,
+		    FALSE, pid)) == NULL)
+				return -1;
+		else {
+        	CloseHandle(hProcess);
+			return 0;
+		}
+	}
+	else return 0;
+}
+
+void gettimeofday( struct timeval * pcur_time,void * tz){
+	struct _timeb current;
+	_ftime(&current);
+	pcur_time->tv_sec=current.time;
+	pcur_time->tv_usec=current.millitm * 1000;
+}
+
+int statfs(const char *path, struct statfs *sfs)
+{
+    char drive[4];
+    DWORD spc, bps, freec, totalc;
+    DWORD vsn, maxlen, flags;
+
+    if (!sfs)
+    {
+		errno=EINVAL;
+		return -1;
+    }
+
+    strncpy(drive,path,2);
+	drive[2]='\0';
+	strcat(drive,"\\");
+
+	if (!GetDiskFreeSpace(drive, &spc, &bps, &freec, &totalc))
+    {
+      errno=ENOENT;
+      return -1;
+    }
+    if (!GetVolumeInformation(drive, NULL, 0, &vsn, &maxlen, &flags, NULL, 0))
+    {
+      errno=ENOENT;
+      return -1;
+    }
+    sfs->f_type = flags;
+    sfs->f_bsize = spc*bps;
+    sfs->f_blocks = totalc;
+    sfs->f_bfree = sfs->f_bavail = freec;
+    sfs->f_files = -1;
+    sfs->f_ffree = -1;
+    sfs->f_fsid = vsn;
+    sfs->f_namelen = maxlen;
+    return 0;
+}
+
+
+static int
+optiserr(int argc, char * const *argv, int oint, const char *optstr,
+         int optchr, int err)
+{
+    if(opterr)
+    {
+        fprintf(stderr, "Error in argument %d, char %d: ", oint, optchr+1);
+        switch(err)
+        {
+        case OPTERRCOLON:
+            fprintf(stderr, ": in flags\n");
+            break;
+        case OPTERRNF:
+            fprintf(stderr, "option not found %c\n", argv[oint][optchr]);
+            break;
+        case OPTERRARG:
+            fprintf(stderr, "no argument for option %c\n", argv[oint][optchr]);
+            break;
+        default:
+            fprintf(stderr, "unknown\n");
+            break;
+        }
+    }
+    optopt = argv[oint][optchr];
+    return('?');
+}
+    
+
+int
+getopt(int argc, char* const *argv, const char *optstr)
+{
+    static int optchr = 0;
+    static int dash = 0; /* have already seen the - */
+
+    char *cp;
+
+    if (optreset)
+        optreset = optchr = dash = 0;
+    if(optind >= argc)
+        return(EOF);
+    if(!dash && (argv[optind][0] !=  '-'))
+        return(EOF);
+    if(!dash && (argv[optind][0] ==  '-') && !argv[optind][1])
+    {
+        /*
+         * use to specify stdin. Need to let pgm process this and
+         * the following args
+         */
+        return(EOF);
+    }
+    if((argv[optind][0] == '-') && (argv[optind][1] == '-'))
+    {
+        /* -- indicates end of args */
+        optind++;
+        return(EOF);
+    }
+    if(!dash)
+    {
+        assert((argv[optind][0] == '-') && argv[optind][1]);
+        dash = 1;
+        optchr = 1;
+    }
+
+    /* Check if the guy tries to do a -: kind of flag */
+    assert(dash);
+    if(argv[optind][optchr] == ':')
+    {
+        dash = 0;
+        optind++;
+        return(optiserr(argc, argv, optind-1, optstr, optchr, OPTERRCOLON));
+    }
+    if(!(cp = strchr(optstr, argv[optind][optchr])))
+    {
+        int errind = optind;
+        int errchr = optchr;
+
+        if(!argv[optind][optchr+1])
+        {
+            dash = 0;
+            optind++;
+        }
+        else
+            optchr++;
+        return(optiserr(argc, argv, errind, optstr, errchr, OPTERRNF));
+    }
+    if(cp[1] == ':')
+    {
+        dash = 0;
+        optind++;
+        if(optind == argc)
+            return(optiserr(argc, argv, optind-1, optstr, optchr, OPTERRARG));
+        optarg = argv[optind++];
+        return(*cp);
+    }
+    else
+    {
+        if(!argv[optind][optchr+1])
+        {
+            dash = 0;
+            optind++;
+        }
+        else
+            optchr++;
+        return(*cp);
+    }
+    assert(0);
+    return(0);
+}
+
+#ifdef TESTGETOPT
+int
+ main (int argc, char **argv)
+ {
+      int c;
+      extern char *optarg;
+      extern int optind;
+      int aflg = 0;
+      int bflg = 0;
+      int errflg = 0;
+      char *ofile = NULL;
+
+      while ((c = getopt(argc, argv, "abo:")) != EOF)
+           switch (c) {
+           case 'a':
+                if (bflg)
+                     errflg++;
+                else
+                     aflg++;
+                break;
+           case 'b':
+                if (aflg)
+                     errflg++;
+                else
+                     bflg++;
+                break;
+           case 'o':
+                ofile = optarg;
+                (void)printf("ofile = %s\n", ofile);
+                break;
+           case '?':
+                errflg++;
+           }
+      if (errflg) {
+           (void)fprintf(stderr,
+                "usage: cmd [-a|-b] [-o <filename>] files...\n");
+           exit (2);
+      }
+      for ( ; optind < argc; optind++)
+           (void)printf("%s\n", argv[optind]);
+      return 0;
+ }
+
+#endif /* TESTGETOPT */
+
+
+
+/**********************************************************************
+ * Implement dirent-style opendir/readdir/closedir on Window 95/NT
+ *
+ * Functions defined are opendir(), readdir() and closedir() with the
+ * same prototypes as the normal dirent.h implementation.
+ *
+ * Does not implement telldir(), seekdir(), rewinddir() or scandir(). 
+ * The dirent struct is compatible with Unix, except that d_ino is 
+ * always 1 and d_off is made up as we go along.
+ *
+ * The DIR typedef is not compatible with Unix.
+ **********************************************************************/
+
+DIR * opendir(const char *dir)
+{
+    DIR *dp;
+    char *filespec;
+    long handle;
+    int index;
+
+    filespec = (char *) malloc(strlen(dir) + 2 + 1);
+    strcpy(filespec, dir);
+    index = strlen(filespec) - 1;
+    if (index >= 0 && (filespec[index] == '/' || filespec[index] == '\\'))
+        filespec[index] = '\0';
+    strcat(filespec, "/*");
+
+    dp = (DIR *)malloc(sizeof(DIR));
+    dp->offset = 0;
+    dp->finished = 0;
+    dp->dir = _strdup(dir);
+
+    if ((handle = _findfirst(filespec, &(dp->fileinfo))) < 0) {
+        if (errno == ENOENT)
+            dp->finished = 1;
+        else
+        return NULL;
+    }
+
+    dp->handle = handle;
+    free(filespec);
+
+    return dp;
+}
+
+struct dirent * readdir(DIR *dp)
+{
+    if (!dp || dp->finished) return NULL;
+
+    if (dp->offset != 0) {
+        if (_findnext(dp->handle, &(dp->fileinfo)) < 0) {
+            dp->finished = 1;
+            return NULL;
+        }
+    }
+    dp->offset++;
+
+    strncpy(dp->dent.d_name, dp->fileinfo.name, _MAX_FNAME);
+    dp->dent.d_ino = 1;
+    dp->dent.d_reclen = strlen(dp->dent.d_name);
+    dp->dent.d_off = dp->offset;
+
+    return &(dp->dent);
+}
+
+int closedir(DIR *dp)
+{
+    if (!dp) return 0;
+    _findclose(dp->handle);
+    if (dp->dir) free(dp->dir);
+    if (dp) free(dp);
+
+    return 0;
+}
+
+#endif
Index: squid/src/access_log.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/access_log.c,v
retrieving revision 1.1.1.3.4.1.2.1
retrieving revision 1.1.1.3.4.1.2.2
diff -u -r1.1.1.3.4.1.2.1 -r1.1.1.3.4.1.2.2
--- squid/src/access_log.c	6 Jan 2001 12:40:11 -0000	1.1.1.3.4.1.2.1
+++ squid/src/access_log.c	14 Jun 2001 20:36:15 -0000	1.1.1.3.4.1.2.2
@@ -1,7 +1,7 @@
 
 
 /*
- * $Id: access_log.c,v 1.1.1.3.4.1.2.1 2001/01/06 12:40:11 hno Exp $
+ * $Id: access_log.c,v 1.1.1.3.4.1.2.2 2001/06/14 20:36:15 serassio Exp $
  *
  * DEBUG: section 46    Access Log
  * AUTHOR: Duane Wessels
Index: squid/src/asn.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/asn.c,v
retrieving revision 1.1.1.3.4.2.2.1
retrieving revision 1.1.1.3.4.2.2.2
diff -u -r1.1.1.3.4.2.2.1 -r1.1.1.3.4.2.2.2
--- squid/src/asn.c	6 Jan 2001 12:40:12 -0000	1.1.1.3.4.2.2.1
+++ squid/src/asn.c	14 Jun 2001 20:36:15 -0000	1.1.1.3.4.2.2.2
@@ -1,5 +1,5 @@
 /*
- * $Id: asn.c,v 1.1.1.3.4.2.2.1 2001/01/06 12:40:12 hno Exp $
+ * $Id: asn.c,v 1.1.1.3.4.2.2.2 2001/06/14 20:36:15 serassio Exp $
  *
  * DEBUG: section 53    AS Number handling
  * AUTHOR: Duane Wessels, Kostas Anagnostakis
@@ -407,7 +407,9 @@
 mask_len(int mask)
 {
     int len = 32;
-    while ((mask & 1) == 0) {
+    if (mask == 0)
+		return 0;
+	while ((mask & 1) == 0) {
 	len--;
 	mask >>= 1;
     }
Index: squid/src/cache_cf.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/cache_cf.c,v
retrieving revision 1.1.1.3.4.4.2.2
retrieving revision 1.1.1.3.4.4.2.3
diff -u -r1.1.1.3.4.4.2.2 -r1.1.1.3.4.4.2.3
--- squid/src/cache_cf.c	3 Jun 2001 19:41:47 -0000	1.1.1.3.4.4.2.2
+++ squid/src/cache_cf.c	14 Jun 2001 20:36:15 -0000	1.1.1.3.4.4.2.3
@@ -1,6 +1,6 @@
 
 /*
- * $Id: cache_cf.c,v 1.1.1.3.4.4.2.2 2001/06/03 19:41:47 serassio Exp $
+ * $Id: cache_cf.c,v 1.1.1.3.4.4.2.3 2001/06/14 20:36:15 serassio Exp $
  *
  * DEBUG: section 3     Configuration File Parsing
  * AUTHOR: Harvest Derived
Index: squid/src/defines.h
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/defines.h,v
retrieving revision 1.1.1.3.4.2.2.1
retrieving revision 1.1.1.3.4.2.2.2
diff -u -r1.1.1.3.4.2.2.1 -r1.1.1.3.4.2.2.2
--- squid/src/defines.h	6 Jan 2001 12:40:13 -0000	1.1.1.3.4.2.2.1
+++ squid/src/defines.h	14 Jun 2001 20:36:15 -0000	1.1.1.3.4.2.2.2
@@ -1,6 +1,6 @@
 
 /*
- * $Id: defines.h,v 1.1.1.3.4.2.2.1 2001/01/06 12:40:13 hno Exp $
+ * $Id: defines.h,v 1.1.1.3.4.2.2.2 2001/06/14 20:36:15 serassio Exp $
  *
  *
  * SQUID Internet Object Cache  http://squid.nlanr.net/Squid/
@@ -287,3 +287,33 @@
 #define NUMTHREADS 16
 #endif
 #endif
+
+/* CygWin & Windows NT Port */
+#if defined(_SQUID_MSWIN_) || defined(_SQUID_CYGWIN_)
+#define _WIN_OS_UNKNOWN	0
+#define _WIN_OS_WIN32S	1
+#define _WIN_OS_WIN95	2
+#define _WIN_OS_WIN98	3
+#define _WIN_OS_WINNT	4
+#define _WIN_OS_WIN2K	5
+#define _WIN_SQUID_SERVICE_CONTROL_STOP SERVICE_CONTROL_STOP
+#define _WIN_SQUID_SERVICE_CONTROL_SHUTDOWN SERVICE_CONTROL_SHUTDOWN
+#define _WIN_SQUID_SERVICE_CONTROL_INTERROGATE SERVICE_CONTROL_INTERROGATE
+#define _WIN_SQUID_SERVICE_CONTROL_ROTATE	128
+#define _WIN_SQUID_SERVICE_CONTROL_RECONFIGURE	129
+#define _WIN_SQUID_SERVICE_CONTROL_DEBUG	130
+#define _WIN_SQUID_SERVICE_CONTROL_INTERRUPT 	131
+#define _WIN_SQUID_DEFAULT_SERVICE_NAME		"SquidNT2.3"
+#define _WIN_SQUID_SERVICE_OPTION		"--ntservice"
+#define _WIN_SQUID_RUN_MODE_INTERACTIVE		0
+#define _WIN_SQUID_RUN_MODE_SERVICE		1
+#ifdef _SQUID_MSWIN_
+#define	SIGHUP	1	/* hangup */
+#define	SIGKILL	9	/* kill (cannot be caught or ignored) */
+#define	SIGBUS	10	/* bus error */
+#define	SIGPIPE	13	/* write on a pipe with no one to read it */
+#define	SIGCHLD	20	/* to parent on child stop or exit */
+#define SIGUSR1 30	/* user defined signal 1 */
+#define SIGUSR2 31	/* user defined signal 2 */
+#endif
+#endif
Index: squid/src/disk.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/disk.c,v
retrieving revision 1.1.1.3.4.1.2.2
retrieving revision 1.1.1.3.4.1.2.3
diff -u -r1.1.1.3.4.1.2.2 -r1.1.1.3.4.1.2.3
--- squid/src/disk.c	25 Mar 2001 16:42:23 -0000	1.1.1.3.4.1.2.2
+++ squid/src/disk.c	14 Jun 2001 20:36:15 -0000	1.1.1.3.4.1.2.3
@@ -1,6 +1,6 @@
 
 /*
- * $Id: disk.c,v 1.1.1.3.4.1.2.2 2001/03/25 16:42:23 serassio Exp $
+ * $Id: disk.c,v 1.1.1.3.4.1.2.3 2001/06/14 20:36:15 serassio Exp $
  *
  * DEBUG: section 6     Disk I/O Routines
  * AUTHOR: Harvest Derived
@@ -70,8 +70,12 @@
 #ifdef _SQUID_MSWIN_ 
 	mode |= _O_BINARY;
     errno = 0;
-    if (mode & O_WRONLY)
-		strcpy(fmode,"a+b");
+    if (mode & O_WRONLY) {
+		if (mode & O_TRUNC)
+		    strcpy(fmode,"wb");
+		else
+    		strcpy(fmode,"a+b");
+	}
 	else
 		strcpy(fmode,"rb");
 	fbuf=fopen(path,fmode);
